# Enchant Filter by SethBling
# Feel free to modify and reuse, but credit to SethBling would be nice.
# http://youtube.com/SethBling

from pymclevel import MCSchematic
from pymclevel import TileEntity
from pymclevel import TAG_Compound
from pymclevel import TAG_Short
from pymclevel import TAG_Byte
from pymclevel import TAG_String
from pymclevel import TAG_Int
from pymclevel import TAG_List
from numpy import zeros

Effects = {
	"Protection": 0,
	"Fire Protection": 1,
	"Feather Falling": 2,
	"Blast Protection": 3,
	"Projectile Protection": 4,
	"Respiration": 5,
	"Aqua Affinity": 6,
	"Thorns": 7,
	"Sharpness": 16,
	"Smite": 17,
	"Bane of Arthropods": 18,
	"Knockback": 19,
	"Fire Aspect": 20,
	"Looting": 21,
	"Efficiency": 32,
	"Silk Touch": 33,
	"Unbreaking": 34,
	"Fortune": 35,
	"Power": 48,
	"Punch": 49,
	"Flame": 50,
	"Infinity": 51,
	}

	

inputs = (
	("Effect", tuple(Effects.keys())),
	("Level", (1, -100, 127)),
)

def perform(level, box, options):
	effect = Effects[options["Effect"]]
	lvl = options["Level"]
	
	minx = int(box.minx/16)*16
	minz = int(box.minz/16)*16

	for (chunk, slices, point) in level.getChunkSlices(box):
		for te in chunk.TileEntities:
			px = te["x"].value
			py = te["y"].value
			pz = te["z"].value

			if px < box.minx or px >= box.maxx:
				continue
			if py < box.miny or py >= box.maxy:
				continue
			if pz < box.minz or pz >= box.maxz:
				continue

				
			if te["id"].value == "Trap" or te["id"].value == "Chest":
				for item in te["Items"]:
					if "tag" not in item:
						item["tag"] = TAG_Compound()
					if "ench" not in item["tag"]:
						item["tag"]["ench"] = TAG_List()
						
					ef = TAG_Compound()
					ef["id"] = TAG_Short(effect)
					ef["lvl"] = TAG_Short(lvl)
					item["tag"]["ench"].append(ef)

						
					chunk.dirty = True
				
