# coding unicode-escape
# ColorArmor Filter by SethBling
# Feel free to modify and reuse, but credit to SethBling would be nice.
# http://youtube.com/SethBling

from pymclevel import MCSchematic
from pymclevel import TileEntity
from pymclevel import TAG_Compound
from pymclevel import TAG_Short
from pymclevel import TAG_Byte
from pymclevel import TAG_String
from pymclevel import TAG_Int
from pymclevel import TAG_List
from numpy import zeros

displayName = "Modify Item Strings"

Colors = {
	"Black": "0",
	"Dark Blue": "1",
	"Dark Green": "2",
	"Dark Aqua": "3",
	"Dark Red": "4",
	"Purple": "5",
	"Gold": "6",
	"Gray": "7",
	"Dark Gray": "8",
	"Indigo": "9",
	"Bright Green": "a",
	"Aqua": "b",
	"Red": "c",
	"Pink": "d",
	"Yellow": "e",
	"White": "f",
	}

inputs = (
	("Name", "string"),
	("Name: Color", tuple(Colors.keys())),
	("Name: Bold", False),
	("Name: Strike", False),
	("Name: Underlined", False),
	("Name: Italics", False),
	("Add Lore", "string"),
	("Lore: Color", tuple(Colors.keys())),
	("Lore: Bold", False),
	("Lore: Strike", False),
	("Lore: Underlined", False),
	("Lore: Italics", True),
)

formatCode = unichr(167)

def perform(level, box, options):
	name = options["Name"]
	lore = options["Add Lore"]
	namecolor = Colors[options["Name: Color"]]
	lorecolor = Colors[options["Lore: Color"]]
	
	for (chunk, slices, point) in level.getChunkSlices(box):
		for te in chunk.TileEntities:
			px = te["x"].value
			py = te["y"].value
			pz = te["z"].value

			if px < box.minx or px >= box.maxx:
				continue
			if py < box.miny or py >= box.maxy:
				continue
			if pz < box.minz or pz >= box.maxz:
				continue

				
			if te["id"].value == "Trap" or te["id"].value == "Chest":
				for item in te["Items"]:
					if "tag" not in item:
						item["tag"] = TAG_Compound()
					if "display" not in item["tag"]:
						item["tag"]["display"] = TAG_Compound()
					if name != "Input String Here":
						fullname = name
						fullname = formatCode + namecolor
						if options["Name: Bold"]:
							fullname = fullname + formatCode + "l"
						if options["Name: Strike"]:
							fullname = fullname + formatCode + "m"
						if options["Name: Underlined"]:
							fullname = fullname + formatCode + "n"
						if options["Name: Italics"]:
							fullname = fullname + formatCode + "o"
						fullname = fullname + name
						item["tag"]["display"]["Name"] = TAG_String(fullname)
						
					if lore != "Input String Here":
						if "Lore" not in item["tag"]["display"]:
							item["tag"]["display"]["Lore"] = TAG_List()
						fulllore = formatCode + lorecolor
						if options["Lore: Bold"]:
							fulllore = fulllore + formatCode + "l"
						if options["Lore: Strike"]:
							fulllore = fulllore + formatCode + "m"
						if options["Lore: Underlined"]:
							fulllore = fulllore + formatCode + "n"
						if options["Lore: Italics"]:
							fulllore = fulllore + formatCode + "o"
						fulllore = fulllore + lore
						item["tag"]["display"]["Lore"].append(TAG_String(fulllore))
						
				chunk.dirty = True
				
