# ColorArmor Filter by SethBling
# Feel free to modify and reuse, but credit to SethBling would be nice.
# http://youtube.com/SethBling

from pymclevel import MCSchematic
from pymclevel import TileEntity
from pymclevel import TAG_Compound
from pymclevel import TAG_Short
from pymclevel import TAG_Byte
from pymclevel import TAG_String
from pymclevel import TAG_Int
from pymclevel import TAG_List
from numpy import zeros

displayName = "Player Skulls"


inputs = (
	("Player Name", "string"),
)

def perform(level, box, options):
	name = options["Player Name"]
	
	for (chunk, slices, point) in level.getChunkSlices(box):
		for te in chunk.TileEntities:
			px = te["x"].value
			py = te["y"].value
			pz = te["z"].value

			if px < box.minx or px >= box.maxx:
				continue
			if py < box.miny or py >= box.maxy:
				continue
			if pz < box.minz or pz >= box.maxz:
				continue

				
			if te["id"].value == "Trap" or te["id"].value == "Chest":
				for item in te["Items"]:
					if item["id"].value == 397 and item["Damage"].value == 3:
						if "tag" not in item:
							item["tag"] = TAG_Compound()
						item["tag"]["SkullOwner"] = TAG_String(name)						
						chunk.dirty = True